<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Pp_model extends CI_Model
{

    public $table = 'pp';
    public $id = 'id_pp';
    public $order = 'DESC';

    function __construct()
    {
        parent::__construct();
    }

    // get all
    function get_all()
    {
        $this->db->order_by($this->table.'.'.$this->id, $this->order);
        return $this->db->get($this->table)->result();
    }

    // get data by id
    function get_by_id($id)
    {
        $this->db->where($this->table.'.'.$this->id, $id);
        return $this->db->get($this->table)->row();
    }
    
    // get total rows
    function total_rows($q = NULL) {
	    if(is_array($q)){
		    extract($q);
		    if($dari && $sampai){
			    $this->db->where($this->table.".tanggal_pp BETWEEN '$dari' AND '$sampai'");
		    }elseif((is_null($dari)== true) && $sampai){
			    $this->db->where($this->table.".tanggal_pp <= '$sampai'");
		    }elseif($dari && is_null($sampai) == true){
			    $this->db->where($this->table.".tanggal_pp >= '$dari'");
		    }
	    }
        $this->db->like('id_pp', $q);
		$this->db->or_like($this->table.'.no_pp', $q);
		$this->db->or_like('proyek.nama_proyek', $q);
		$this->db->or_like($this->table.'.id_proyek', $q);
		$this->db->or_like($this->table.'.id_gudang', $q);
		$this->db->or_like('gudang.nama_gudang', $q);
		$this->db->or_like($this->table.'.tanggal_pp', $q);
		$this->db->join('proyek', $this->table.'.id_proyek = proyek.id_proyek','left');
		$this->db->join('gudang', $this->table.'.id_gudang = gudang.id_gudang','left');
		$this->db->from($this->table);
        return $this->db->count_all_results();
    }

    // get data with limit and search
    function get_limit_data($limit, $start = 0, $q = NULL) {
	    if(is_array($q)){
		    extract($q);
		    if($dari && $sampai){
			    $this->db->where($this->table.".tanggal_pp BETWEEN '$dari' AND '$sampai'");
		    }elseif((is_null($dari)== true) && $sampai){
			    $this->db->where($this->table.".tanggal_pp <= '$sampai'");
		    }elseif($dari && is_null($sampai) == true){
			    $this->db->where($this->table.".tanggal_pp >= '$dari'");
		    }
	    }
        $this->db->order_by($this->table.'.'.$this->id, $this->order);
        $this->db->like('id_pp', $q);
	$this->db->or_like($this->table.'.no_pp', $q);
	$this->db->or_like($this->table.'.id_proyek', $q);
	$this->db->or_like('proyek.nama_proyek', $q);
	$this->db->or_like($this->table.'.id_gudang', $q);
	$this->db->or_like('gudang.nama_gudang', $q);
//	$this->db->or_like($this->table.'.tanggal_pp', $q);
	$this->db->limit($limit, $start);
	$this->db->join('proyek', $this->table.'.id_proyek = proyek.id_proyek','left');
	$this->db->join('gudang', $this->table.'.id_gudang = gudang.id_gudang','left');
	
        return $this->db->get($this->table)->result();
    }

    // insert data
    function insert($data)
    {
        $this->db->insert($this->table, $data);
	    $isert_id = $this->db->insert_id();
	    return $isert_id;
    }

    // update data
    function update($id, $data)
    {
        $this->db->where($this->table.'.'.$this->id, $id);
        $this->db->update($this->table, $data);
    }

    // delete data
    function delete($id)
    {
        $this->db->where($this->table.'.'.$this->id, $id);
        $this->db->delete($this->table);
    }

	function getkodeunik() {
		$q = $this->db->query("SELECT MAX(RIGHT(no_pp,4)) AS idmax FROM ".$this->table);
		$kd = ""; //kode awal
		if($q->num_rows()>0){ //jika data ada
			$data = $q->row();
			if($data->idmax){
				foreach($q->result() as $k){
					$tmp = ((int)$k->idmax)+1; //string kode diset ke integer dan ditambahkan 1 dari kode terakhir
					$kd = sprintf("%'.04d", $tmp); //kode ambil 4 karakter terakhir
				}
			}else{
				$kd = "0001";
			}

		}else{ //jika data kosong diset ke kode awal
			$kd = "0001";
		}
		$kar = "PP."; //karakter depan kodenya
		//gabungkan string dengan kode yang telah dibuat tadi
		return $kar.$kd;
	}

}

/* End of file Pp_model.php */
/* Location: ./application/models/Pp_model.php */
/* Please DO NOT modify this information : */
/* Generated by Harviacode Codeigniter CRUD Generator 2017-07-02 16:46:00 */
/* http://harviacode.com */